"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var uuid_1 = require("./../../utils/uuid");
var index_1 = require("./../../renderer/SvgHelper/index");
var Baseboard = (function () {
    function Baseboard(source) {
        var _this = this;
        this.id = uuid_1.uuid();
        this.initBoard = function () {
            _this.boardHolder = document.createElement('div');
            _this.boardHolder.id = "fcw-board-holder-" + _this.id;
            _this.boardHolder.style.setProperty('touch-action', 'none');
            _this.boardHolder.style.setProperty('-ms-touch-action', 'none');
            document.body.appendChild(_this.boardHolder);
            _this.boardCanvas = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
            _this.boardCanvas.setAttribute('xmlns', 'http://www.w3.org/2000/svg');
            _this.boardCanvas.setAttribute('width', _this.width.toString());
            _this.boardCanvas.setAttribute('height', _this.height.toString());
            _this.boardCanvas.setAttribute('viewBox', '0 0 ' + _this.width.toString() + ' ' + _this.height.toString());
            _this.boardHolder.style.position = 'absolute';
            _this.boardHolder.style.width = _this.width + "px";
            _this.boardHolder.style.height = _this.height + "px";
            _this.boardHolder.style.transformOrigin = 'top left';
            _this.positionBoard();
            _this.defs = index_1.SvgHelper.createDefs();
            _this.boardCanvas.appendChild(_this.defs);
            _this.boardHolder.appendChild(_this.boardCanvas);
        };
        this.positionBoard = function () {
            _this.boardHolder.style.top = _this.targetRect.top + 'px';
            _this.boardHolder.style.left = _this.targetRect.left + 'px';
        };
        this.source = source;
        if (source.imgEle) {
            this.target = source.imgEle;
            this.width = this.target.clientWidth;
            this.height = this.target.clientHeight;
        }
    }
    return Baseboard;
}());
exports.Baseboard = Baseboard;
