"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./HighlightMarker/index");
var index_2 = require("./TextMarker/index");
var index_3 = require("./ArrowMarker/index");
var index_4 = require("./BaseMarker/index");
var CoverMarker_1 = require("./CoverMarker");
var LineMarker_1 = require("./LineMarker");
var RectMarker_1 = require("./RectMarker");
function getMarkerByType(type) {
    switch (type) {
        case 'arrow':
            return index_3.ArrowMarker;
        case 'base':
            return index_4.BaseMarker;
        case 'cover':
            return CoverMarker_1.CoverMarker;
        case 'highlight':
            return index_1.HighlightMarker;
        case 'line':
            return LineMarker_1.LineMarker;
        case 'rect':
            return RectMarker_1.RectMarker;
        case 'text':
            return index_2.TextMarker;
        default:
            return index_4.BaseMarker;
    }
}
exports.getMarkerByType = getMarkerByType;
