"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./../markers/RectMarker/index");
var index_2 = require("./../markers/CoverMarker/index");
var index_3 = require("./../markers/TextMarker/index");
var index_4 = require("./../markers/ArrowMarker/index");
var index_5 = require("./../markers/HighlightMarker/index");
var ToolbarItem_1 = require("./ToolbarItem");
var LineMarker_1 = require("../markers/LineMarker");
var OkIcon = require('../assets/check.svg');
var DeleteIcon = require('../assets/eraser.svg');
var PointerIcon = require('../assets/mouse-pointer.svg');
var CloseIcon = require('../assets/times.svg');
exports.highlightMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'cover-marker',
    tooltipText: 'Cover',
    icon: require('../assets/highlight.svg'),
    markerType: index_5.HighlightMarker
});
exports.arrowMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'arrow-marker',
    tooltipText: 'Arrow',
    icon: require('../assets/arrow.svg'),
    markerType: index_4.ArrowMarker
});
exports.textMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'text-marker',
    tooltipText: 'Text',
    icon: require('../assets/text.svg'),
    markerType: index_3.TextMarker
});
exports.coverMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'cover-marker',
    tooltipText: 'Cover',
    icon: require('../assets/cover.svg'),
    markerType: index_2.CoverMarker
});
exports.rectMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'rect-marker',
    tooltipText: 'Rectangle',
    icon: require('../assets/rect.svg'),
    markerType: index_1.RectMarker
});
exports.lineMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'line-marker',
    tooltipText: 'Line',
    icon: require('../assets/line.svg'),
    markerType: LineMarker_1.LineMarker
});
function getToolbars(page) {
    var toolbars = [
        {
            icon: PointerIcon,
            name: 'pointer',
            tooltipText: 'Pointer'
        },
        {
            icon: DeleteIcon,
            name: 'delete',
            tooltipText: 'Delete'
        },
        {
            name: 'separator',
            tooltipText: ''
        },
        exports.rectMarkerToolbarItem,
        exports.coverMarkerToolbarItem,
        exports.highlightMarkerToolbarItem,
        exports.lineMarkerToolbarItem,
        exports.arrowMarkerToolbarItem,
        exports.textMarkerToolbarItem,
        {
            name: 'separator',
            tooltipText: ''
        }
    ];
    if (!page) {
        toolbars.push.apply(toolbars, [
            {
                icon: OkIcon,
                name: 'ok',
                tooltipText: 'OK'
            }
        ]);
    }
    toolbars.push({
        icon: CloseIcon,
        name: 'close',
        tooltipText: 'Close'
    });
    return toolbars;
}
exports.getToolbars = getToolbars;
