import { WhitePageSource } from './../types';
import { Baseboard } from './../Baseboard/index';
import { BaseMarker } from './../../markers/BaseMarker/index';
import { WhitePage } from './../WhitePage/index';
import { onSyncFunc } from './../../event/Event';
import './index.less';
export declare class Drawboard extends Baseboard {
    private scale;
    page: WhitePage;
    private markers;
    readonly markerMap: {
        [key: string]: BaseMarker;
    };
    private activeMarker;
    private toolbar;
    private toolbars;
    private toolbarUI;
    private onComplete;
    private onChange;
    private onCancel;
    constructor(source: WhitePageSource, { page, onChange }?: {
        page?: WhitePage;
        onChange?: onSyncFunc;
    });
    open: (onComplete?: ((dataUrl: string) => void) | undefined, onCancel?: (() => void) | undefined) => void;
    hide: () => void;
    show: () => void;
    close: () => void;
    render: (onComplete: (dataUrl: string) => void, onCancel?: (() => void) | undefined) => void;
    addMarker: (markerType: typeof BaseMarker, { id }?: {
        id?: string | undefined;
    }) => void;
    deleteActiveMarker: () => void;
    private setTargetRect;
    private startRender;
    private attachEvents;
    private mouseDown;
    private mouseMove;
    private mouseUp;
    private adjustUI;
    private adjustSize;
    private positionUI;
    private positionToolbar;
    private showUI;
    private setStyles;
    private toolbarClick;
    private selectMarker;
    deleteMarker: (marker: BaseMarker) => void;
    private complete;
    private cancel;
    private renderFinished;
    private renderFinishedClose;
}
