import { EventHub } from '../../event/EventHub';
import { WhiteboardMode, WhitePageSource } from './../types';
import { Drawboard } from './../Drawboard/index';
import './index.less';
export declare class WhitePage {
    id: string;
    source: WhitePageSource;
    target: HTMLImageElement;
    container: HTMLDivElement;
    parentContainer?: HTMLDivElement;
    mode: WhiteboardMode;
    drawboard: Drawboard;
    eventHub?: EventHub;
    constructor(source: WhitePageSource, { mode, eventHub, parentContainer }?: {
        mode?: WhiteboardMode;
        eventHub?: EventHub;
        parentContainer?: HTMLDivElement;
    });
    open(): void;
    hide(): void;
    show(): void;
    close(): void;
    private initSource;
    protected initMaster(): void;
    protected initMirror(): void;
    private onPageSync;
    private onMarkerSync;
}
