import { WhiteboardMode } from '../types';
import { WhitePage } from '../WhitePage/index';
import { EventHub } from '../../event/EventHub';
import './index.less';
export declare class SerializableWhiteboard {
    id: string;
    sources: string[];
    pageIds: string[];
    visiblePageIndex: number;
}
export declare class Whiteboard {
    id: string;
    sources: string[];
    target: HTMLDivElement;
    imgsContainer: HTMLDivElement;
    pagesContainer: HTMLDivElement;
    eventHub?: EventHub;
    mode: WhiteboardMode;
    isFullscreen: boolean;
    pages: WhitePage[];
    readonly activePage: WhitePage;
    siema: any;
    isInitialized: boolean;
    visiblePageIndex: number;
    emitInterval: any;
    constructor(target: HTMLDivElement, { sources, eventHub, mode, visiblePageIndex }?: {
        sources?: string[];
        eventHub?: EventHub;
        mode?: WhiteboardMode;
        visiblePageIndex?: number;
    });
    open(): void;
    close(): void;
    show(): void;
    hide(): void;
    snap(): SerializableWhiteboard;
    private init;
    private initMaster;
    private initMirror;
    private initSiema;
    private onPageChange;
    private emitSnapshot;
    private onSnapshot;
}
