export declare type TargetType = 'whiteboard' | 'page' | 'marker';
export declare type EventType = 'snap' | 'add' | 'resize' | 'move' | 'remove' | 'changeIndex' | 'changeText';
export declare type PositionType = 'left' | 'right' | 'topLeft' | 'bottomLeft' | 'topRight' | 'bottomRight' | 'centerLeft' | 'centerRight' | 'topCenter' | 'bottomCenter';
export interface SyncEvent {
    target: TargetType;
    id?: string;
    parentId?: string;
    event: EventType;
    data?: object | string | number;
}
export declare type onSyncFunc = (ev: SyncEvent) => void;
