import { WhitePage } from './../../board/WhitePage/index';
import { PositionType } from '../../event/Event';
import { onSyncFunc, EventType } from '../../event/Event';
import { MarkerType } from '../types';
export declare class BaseMarker {
    id: string;
    type: MarkerType;
    page?: WhitePage;
    onChange: onSyncFunc;
    static createMarker: (page?: WhitePage | undefined) => BaseMarker;
    visual: SVGGElement;
    renderVisual: SVGGElement;
    onSelected: (marker: BaseMarker) => void;
    defs: SVGElement[];
    protected width: number;
    protected height: number;
    protected isActive: boolean;
    protected isDragging: boolean;
    protected isResizing: boolean;
    protected previousMouseX: number;
    protected previousMouseY: number;
    reactToManipulation(type: EventType, { dx, dy, pos }: {
        dx: number;
        dy: number;
        pos: PositionType;
    }): void;
    manipulate: (ev: MouseEvent) => void;
    endManipulation(): void;
    select(): void;
    deselect(): void;
    protected setup(): void;
    protected addToVisual: (el: SVGElement) => void;
    protected addToRenderVisual: (el: SVGElement) => void;
    protected resize(x: number, y: number, cb?: Function): void;
    protected resizeByEvent(x: number, y: number, pos?: PositionType): void;
    protected onTouch(ev: TouchEvent): void;
    private mouseDown;
    private mouseUp;
    private mouseMove;
    private move;
}
