export declare class SvgHelper {
    static createRect: (width: string | number, height: string | number, attributes?: [string, string][] | undefined) => SVGRectElement;
    static createLine: (x1: string | number, y1: string | number, x2: string | number, y2: string | number, attributes?: [string, string][] | undefined) => SVGLineElement;
    static createPolygon: (points: string, attributes?: [string, string][] | undefined) => SVGPolygonElement;
    static createCircle: (radius: number, attributes?: [string, string][] | undefined) => SVGCircleElement;
    static createGroup: (attributes?: [string, string][] | undefined) => SVGGElement;
    static setAttributes: (el: SVGElement, attributes: [string, string][]) => void;
    static createTransform: () => SVGTransform;
    static createDefs: () => SVGDefsElement;
    static createMarker: (id: string, orient: string, markerWidth: string | number, markerHeight: string | number, refX: string | number, refY: string | number, markerElement: SVGGraphicsElement) => SVGMarkerElement;
    static createText: (attributes?: [string, string][] | undefined) => SVGTextElement;
    static createTSpan: (text: string, attributes?: [string, string][] | undefined) => SVGTSpanElement;
}
