import { PositionType } from '../../event/Event';
import { SvgHelper } from '../../renderer/SvgHelper';
import { RectangularMarker } from '../RectangularMarker';
import { WhitePage } from '../../board/WhitePage';

export class RectBaseMarker extends RectangularMarker {
  public static createMarker = (page?: WhitePage): RectBaseMarker => {
    const marker = new RectBaseMarker();
    marker.page = page;
    marker.setup();
    return marker;
  };

  private markerRect: SVGRectElement;

  protected setup() {
    super.setup();

    this.markerRect = SvgHelper.createRect(this.width, this.height);
    this.addToRenderVisual(this.markerRect);
  }

  protected resize(x: number, y: number, onPosition?: (pos: PositionType) => void) {
    super.resize(x, y, onPosition);
    this.markerRect.setAttribute('width', this.width.toString());
    this.markerRect.setAttribute('height', this.height.toString());
  }
}
